#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "flann.h"
#include <cv.h>

#define MAX_PATH_LEN 1024
#define MAX_LINE_WIDTH 20000 
#define TOKEN_WIDTH 64
/* For SURF HOOF and SURF LBP*/
#define DELIM " "
#define NN 1
#define CHECK_NN_SEARCH 2048

struct program_params{
  int mode;
  int nclusters;
  char data_file[MAX_PATH_LEN];
  char count_file[MAX_PATH_LEN];
  char codebook_file[MAX_PATH_LEN]; /* output or input codebook */
  char bow_file[MAX_PATH_LEN]; /* output quantization file */
  char idx_file[MAX_PATH_LEN]; /* output index file */
};
typedef struct program_params P_PARAMS;
   
/* Core routines */
void create_codebook (float *data, long int nDataPts, 
    long int nDataDim, int nclusters, float *centers_data, int *memberships, 
    float *data_dists);
void quantize_datapoints (float *centers_data, float *data_dists, int nclusters, 
    float *data, int *memberships,long int nDataPts, long int nDataDim, 
    int num_samples, int *data_count, CvMat **bow_representation);
void quantize_single_file (float *centers_data, float *data_dists, int nclusters, 
    int *memberships,long int nDataPts, CvMat **bow_representation);

void init_FLANN_clustering (FLANNParameters *p);
void init_FLANN_indexing (FLANNParameters* p);
void init_FLANN_searching (FLANNParameters* p);
  
/* IO-specific functions */
void usage (char* pname);
int parse_options (int argc, char *argv[], P_PARAMS *p);

float* parse_data_file (char *filepath, long int *nDataPts, long int *nDataDim);
void write_data (long int rows, long int cols, float *data, char *fname);
void print_matrix (CvMat *dataMat, char *fname);
int *read_data_count (char *filepath, int *num_samples);
