#!/bin/bash
# Script to Sample a fraction of random data-points, given a list of 
# files containing those datapoints.

# sb3564@columbia.edu

# Input validation
if [ $# -lt 3 ]; then
  echo "Usage: $0 <inputfilelist> <fraction> <outputfilename>";
  exit;
fi

if [ ! -s $1 ]; then
  echo "List file $1 is non-existent. Aborting.";
  exit;
fi
lfile=$1;
frac=$2;
ofile=$3;

echo "Selecting random datapoints from list $lfile. Progress.";
echo "";

tf=`wc -l $lfile|cut -d' ' -f1`;
intv=`echo "scale=3.2; $tf/150"|bc|cut -d. -f1`;
fc=1;
for f in `cat $lfile`; do 
  if [[ -s $f ]]; then
    nl=`wc -l $f|cut -d' ' -f1`;
    ct=`echo "scale=3.2; $nl*$frac+1"|bc|cut -d. -f1`; 
    shuf -n $ct $f >> $ofile;
  fi
  # Showing Progress information
  if [[ `echo "$fc % $intv"|bc` -eq 0 ]]; then
    echo -n "+";
  fi
  let fc=$fc+1;
done
